

// Fichier Depart_Bleue.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *			Recharge le barillet cot Bleue				*
 *                                                      *
 * .Date de cration : 23/04/08                         *
 * .Auteur : Jrmie LUMINEAU							*       
 *                                                      *
 * .Descriptions :                                      *
 *      - code du rechargement du barillet							*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"

#include "strategie_bleue.h"
#include "Recharge_barillet_Bleue.h"
#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "Horloge.h"
#include "strategie_bleue.h"
#include "led.h"
#include "Telemetres.h"
#include "serial.h"
#include "canon.h"
#include "Tourelle.h"




extern unsigned char		Nb_Balles_Distributeur_Blanc_Bleu;						// Nombre de balles dans le distributeur blanc du ct bleu
extern unsigned char		Nb_Balles_Distributeur_Bleu;								// Nombre de balles dans le distributeur bleu
extern unsigned char		Nb_Balles_Distributeur_Blanc_Rouge;						// Nombre de balles dans le distributeur blanc du ct rouge






// --------------------------------------------------------------------------
/* 
 * Rammasse les deux premires balles bleues sur la table
 * Prends 3 balles au distributeur blanc
 * Fait le complment de bleues si ncessaire
 * Va tout dposer dans le conteneur standard
*/
void Rechargement_Barillet_Bleue (unsigned char Nb_Voyages)
{
	char 			config=0;								// Position de l'adversaire	
	// ------------------------------------------------------------------
	// Phase 1 : Localisation de l'adversaire et choix de la stratgie
	//	
	
	if (NbBalles_Barillet(TOUTES)<5)												// Si on est pas plein, on active les rouleaux
		Commande_Rouleaux(90, 90);	
	
	config=1;																		// Config 1 par dfaut, on retourne de notre ct
	if (Angle_Robot_Adverse()>160 && Distance_Robot_Adverse()!=0)					// Si on sait ou est l'adversaire et qu'il est de notre ct
		config=2;																	// On va lui prendre ses balles
	
	
	
	if (config==1)
	{
		print_str ("Ph 4a: Chez nous\n");									// Config 1: on rentre au bercaille
		Goto_Cote_Bleu ();												// On va vers nos distributeurs
			
		if(	Distance_Robot_Adverse())
		{
			if ( (Angle_Absolu_Robot_Adverse()<PI/4.0) && 				// S'il n'est pas au distributeur blanc
				(Angle_Absolu_Robot_Adverse()>-PI/4.0))
				config=2;												// On continue normalement
		
		}					
	}
	
	
	
	
	if (config==2)
	{
	 	print_str ("Ph 4b: Distri ad\n");										// Config 2: on va lui prendre des balles
																						
		GotoXY_Propulsion(500,750,100);									// On y va en avant
		while (	Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');

		
		// On prend des balles blanches  l'adversaire
		
		
		if (Etat_Propulsion ()=='a')
		{
			Angle_Propulsion (PI,25);										// S'oriente perpendiculaire  la largeur de la table ...
			while (Etat_Propulsion ()!='a' 									// ... pour tre face au distributeur
			&& NbBalles_Barillet(BLANCHE)<2);									
	
			GotoXY_Propulsion(0,750,25);									// On avance vers le distributeur
			while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) &&					// Soit on a les switchs ...
					Etat_Propulsion()!='g' &&								// ... soit on est bloqu ...
					Etat_Propulsion()!='a');								// ... soit on est arriv !!!
																						
		
			if (Distributeur_Blanc_Rouge (Nb_Voyages+1,0))					// ... on choppe deux balles au distributeur
			{
				Stop_Propulsion();
				ToutDroit_Propulsion (100, -70);				// On recule de 10cm		
				while ( Etat_Propulsion()!='a' &&
						Etat_Propulsion()!='g' );
						
				Angle_Propulsion(-PI/2.0,50);					// On tourne de 90
				while ( Etat_Propulsion()!='a' &&
						Etat_Propulsion()!='g' );
						
				ToutDroit_Propulsion (500, -80);				// On recule de 50cm		
				while ( Etat_Propulsion()!='a' &&
						Etat_Propulsion()!='g' );				
			}
				
			if (NbBalles_Barillet(TOUTES)<5)								// Si on est pas plein, on active les rouleaux
				Commande_Rouleaux(90, 90);	
		}
		else
		{
			Stop_Propulsion();									// On stoppe les moteurs
			ToutDroit_Propulsion(150,-50);						// On recule de 15cm
		
			while (	Etat_Propulsion ()!='a' &&					// Jusqu'au blocage ou l'arrt
					Etat_Propulsion ()!='g');
		}
		
		Goto_Cote_Bleu_Arriere ();											// On retourne du ct bleu											
	}
	
	
		
						
	if (!(Distance_Robot_Adverse()!=0 &&									// Que l'on voit le robot adverse
		Angle_Absolu_Robot_Adverse()<0 &&									// Est qu'il n'est pas dans le coin
	 	Angle_Absolu_Robot_Adverse()>-PI/2.0))						
	{
		
		Angle_Propulsion (-PI/4,50);										// S'oriente en direction du coin
		while (Etat_Propulsion ()!='a');									// ... pour tre face au distributeur
			
		GotoXY_Propulsion (2650,350,60);									// Avance au point de recalage
		while (	Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');	
				
		if ( NbBalles_Barillet(BLANCHE)>=2)											
			Recal_Cote_Bleu (1,0);											// Recale le robot en X, Y et en Psi
		else
			Recal_Cote_Bleu (1,1);											// Recale le robot en X, Y et en Psi
	}

						
								
	if (NbBalles_Barillet(BLANCHE)<2)										// Si on a pas les deux balles blanches
	{
		if(	!Distance_Robot_Adverse() || 									// Si on ne voit pas l'adversaire ...
			Angle_Absolu_Robot_Adverse()>PI/4.0 ||							// .. ou s'il n'est pas au distributeur blanc
			Angle_Absolu_Robot_Adverse()<-PI/4.0 )									
		{

			Angle_Propulsion (0,45);													// S'oriente perpendiculaire  la largeur de la table ...
			while (Etat_Propulsion ()!='a'); 											// ... pour tre face au distributeur

			Angle_Propulsion (0,25);													// S'oriente perpendiculaire  la largeur de la table ...
			while (Etat_Propulsion ()!='a'); 											// ... pour tre face au distributeur
			
			GotoXY_Propulsion(	3000, 750, 50 );										// Avance en face du distributeur
			while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 
				&& Etat_Propulsion()!='g' &&
				X_Propulsion()<2600);	
													
			GotoXY_Propulsion(	3000, 750, 25 );										// Avance en face du distributeur
			while (	! (IO_Sw_Gauche() || IO_Sw_Droit()) 
				&& Etat_Propulsion()!='g');	
					
			if (Nb_Voyages==1)
				Distributeur_Blanc_Bleu(2,0);											// Prends 2 balles dans le distributeur blanc du ct bleu
			else
				Distributeur_Blanc_Bleu(Nb_Balles_Distributeur_Blanc_Bleu,0);					// Prends ce qu'il reste dans le distributeur blanc du ct bleu
				
			GotoXY_Propulsion(2300, 500, -50);											// On recule dans l'alignement du distributeur
			while (Etat_Propulsion ()!='a' &&
				Etat_Propulsion ()!='g');
		}
	}
					
					
					
	while (NbBalles_Barillet(BLANCHE)>2 && Nb_Voyages==1)							// Si on a ramasser plus de deux balles blanche et qu'on est au deuxime voyage
	{
		if (!DeposeBalle_Barillet(BLANCHE));										// On ejecte le trop plein
		{
			while(!Barillet_Busy());												// On attends la fin de l'jection
			while(Barillet_Busy());
		}
	}
	
	
					
					
	if (NbBalles_Barillet(BLEUE)<3 && NbBalles_Barillet(TOUTES)<5) 					// Si on a pas les trois balles bleues et qu'il reste de la place
	{

		
		Angle_Propulsion (-PI/2.0,35);												// S'oriente en face du distributeur
		while (Etat_Propulsion ()!='a');
	
		GotoXY_Propulsion(2300, 0, 50);												// Avancer vers le distributeur en avant
		while (	Etat_Propulsion ()!='g' &&											// On arrte si on est bloqu ...
				Etat_Propulsion ()!='a' && 											// ... ou si on est arriv (l il y a un problme !)...
				Y_Propulsion ()>440 &&												// ... ou on est proche du distributeur
				NbBalles_Barillet(BLEUE)<3);										// ... ou si on a les 3 balles blanches
				
		Stop_Propulsion();															// On arrte les moteurs
		if (Nb_Voyages==1)
			Distributeur_Bleu(3);													// Prends trois balles dans le distributeur
		else
			Distributeur_Bleu(Nb_Balles_Distributeur_Bleu);							// Prends trois balles dans le distributeur
		if (NbBalles_Barillet(TOUTES)==5)											// Si on a les 5 balles ..
			Commande_Rouleaux(-90, -90);											// On fait tourner les rouleaux pour ne pas en prendre une sixieme
	}
}
