// Fichier Strategie.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *					strategie							*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la straegie   		*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"

#include "strategie_bleue.h"
#include "Constante.h"					// Constantes



volatile unsigned char		Nb_Balles_Distributeur_Blanc_Bleu=5;						// Nombre de balles dans le distributeur blanc du ct bleu
volatile unsigned char		Nb_Balles_Distributeur_Bleu=5;								// Nombre de balles dans le distributeur bleu
volatile unsigned char		Nb_Balles_Distributeur_Blanc_Rouge=5;						// Nombre de balles dans le distributeur blanc du ct rouge


volatile unsigned char 		Nb_Depose_Adverse=0;										// Nombre de dposes chez l'dversaire
// --------------------------------------------------------------------------
/* Retourne du ct bleu align sur les deux distributeurs
 * Normalement on vite le robot adverse. Au bout de trois fois, 
 * on passe en force
 * Arguments : 
 *   Aucun
 * 
 * Paramtre retourn : 
 *   Aucun
*/
unsigned char Goto_Cote_Bleu (void)
{
	char	NbEvitements=0;										// Nombre d'vitements du robot adverse		
	float 	Angle_Adverse;										// Angle avec le robot adverse en radian
	float 	Angle_Robot;										// Orientation du robot avant la dtection de l'adversaire
	
	
	GotoXY_Propulsion(2300,750,VIT_RAPIDE);						// Se dplace jusqu'au point demand en marche avant
	while (Etat_Propulsion ()!='a')
	{
//		Delay10KTCYx(1);										// Tempo pour viter les lectures trop rapides
		
		
		if (Etat_Propulsion()=='g')								// Si le robot est bloqu
		{
			Stop_Propulsion();
			Delay10KTCYx(200);

			ToutDroit_Propulsion(150,-40);						// On recule
			while ( Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');
			Evite_Robot_Adverse();								// Routine d'vitement du robot adverse
				NbEvitements++;
			if (NbEvitements>=4)											// Aprs 3 vitements et un forage, on est pas pass : tant pis :
			{
				Stop_Propulsion();
				while (Etat_Propulsion()!='a');
			}
			else
				GotoXY_Propulsion(2300,750,VIT_RAPIDE);					// Se dplace jusqu'au point demand en marche avant
		}
		
		
		if 	((Angle_Robot_Adverse()>96  && 						// Si le robot est potentiellement sur la trajectoire
			Angle_Robot_Adverse()<159) ||
			Distance_Robot_Adverse()==0)						// On si on ne le voit pas !
										
		{		
			if 	((Telemetre_Avant_Droit()>DISTANCE_OBSTACLE ||	// On teste les capteurs  droite ...
				Telemetre_Avant_Gauche()>DISTANCE_OBSTACLE)	&&	// ... et  gauche
				(NbEvitements<3))								// On ne l'a pas vit 3 fois
			{
				Stop_Propulsion();								// On arrte le robot
				while (	Etat_Propulsion ()!='a');				// On attends d'tre compltement stopp
				Evite_Robot_Adverse();							// Routine d'vitement du robot adverse
				NbEvitements++;
				GotoXY_Propulsion(2300,750,VIT_RAPIDE);			// Se dplace jusqu'au point demand en marche avant
			}
		}
		
	}
	Stop_Propulsion();											// Manifestement, on est arriv !
	return NbEvitements;
}







// --------------------------------------------------------------------------
/* Retourne du ct bleu align sur les deux distributeurs en marche arrire
 * Normalement on vite le robot adverse. Au bout de trois fois, 
 * on passe en force
 * Arguments : 
 *   Aucun
 * 
 * Paramtre retourn : 
 *   Aucun
*/
unsigned char Goto_Cote_Bleu_Arriere (void)
{
	char	NbEvitements=0;										// Nombre d'vitements du robot adverse		
	float 	Angle_Adverse;										// Angle avec le robot adverse en radian
	float 	Angle_Robot;										// Orientation du robot avant la dtection de l'adversaire
	
	
	GotoXY_Propulsion(2300,750,-VIT_LENTE);						// Se dplace jusqu'au point demand en marche avant
	while (Etat_Propulsion ()!='a')
	{
//		Delay10KTCYx(1);										// Tempo pour viter les lectures trop rapides
		
		
		if (Etat_Propulsion()=='g')								// Si le robot est bloqu
		{
			Stop_Propulsion();
			Delay10KTCYx(200);
			ToutDroit_Propulsion(150,40);						// On recule
			while ( Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');
			Evite_Robot_Adverse();								// Routine d'vitement du robot adverse
				NbEvitements++;
			if (NbEvitements>=4)								// Aprs 3 vitements et un forage, on est pas pass : tant pis :
			{
				Stop_Propulsion();
				while (Etat_Propulsion()!='a');
			}
			else		
				GotoXY_Propulsion(2300,750,-VIT_LENTE);			// Se dplace jusqu'au point demand en marche avant
		}
				
		
		if 	(Angle_Robot_Adverse()<32  || 						// Si le robot est potentiellement sur la trajectoire
			Angle_Robot_Adverse()>223 ||
			Distance_Robot_Adverse()==0)						// On si on ne le voit pas !
										
		{		
			if 	((Telemetre_Arriere_Droit()>90 ||				// On teste les capteurs  droite ...
				Telemetre_Arriere_Gauche()>90)	&&				// ... et  gauche
				(NbEvitements<3))								// On ne l'a pas vit 3 fois
			{
				Stop_Propulsion();								// On arrte le robot
				while (	Etat_Propulsion ()!='a');				// On attends d'tre compltement stopp
				Evite_Robot_Adverse();							// Routine d'vitement du robot adverse
				NbEvitements++;
				GotoXY_Propulsion(2300,750,-VIT_LENTE);			// Se dplace jusqu'au point demand en marche arrire
			}
		}
		else
		{
			GotoXY_Propulsion(2200,750,-VIT_RAPIDE);			// Se dplace jusqu'au point demand en marche arrire  fond
			while ( Angle_Robot_Adverse()>=32  &&				// Jusqu' ce que le robot revienne sur la trajectoire ...
					Angle_Robot_Adverse()<=223 &&		
					Distance_Robot_Adverse()!=0 &&				// ... ou si on ne le voit plus ... 
					Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');					// ... ou qu'on est arriv ...
			if (Etat_Propulsion()!='a')							// Si on est pas arriv ...
				GotoXY_Propulsion(2300,750,-VIT_LENTE);			// ... on ralentit !
		}		
	}
	Stop_Propulsion();											// Manifestement, on est arriv !
	return NbEvitements;
}





// --------------------------------------------------------------------------
/* Va se placer contre le conteneur standard en marche arrire.
 * Normalement on vite le robot adverse. Au bout de trois fois, 
 * on passe en force
 * Arguments : 
 *  - La position en X du point de dpose 
 * 
 * Paramtre retourn : 
 *   Le nombre de fois qu'on a vit l'adversaire
*/
unsigned char Goto_Conteneur (int X)
{
	char	NbEvitements=0;													// Nombre d'vitements du robot adverse		
	float 	Angle_Adverse;													// Angle avec le robot adverse en radian
	float 	Angle_Robot;													// Orientation du robot avant la dtection de l'adversaire
	
	int 	Flag_Inter=0;													// Flag qui passe  1 quand on traque un point intermdiaire
	int 	XTarget,YTarget;												// Points de passage intermdaire
	long int Distance_Cible;												// Distance entre le robot et la cible
	long int Xrobot,Yrobot;													// Coordonnes du robot
	
	// ------------------------------------------------------------------
	// Phase 0 : Localisation de l'adversaire et cration de la trajectoire
	//
	
	if (Distance_Robot_Adverse()==0)										// On ne voit pas l'adversaire
	{
		XTarget=X;															// On va directement sur le conteneur
		YTarget=Y_CONTENEUR;
		Flag_Inter=0;
	}
	else
	{		
		Angle_Adverse=Angle_Absolu_Robot_Adverse();
		if (Angle_Adverse>-0.5-PI/2.0 && Angle_Adverse<-0.5+PI/2.0)			// Robot adv derriere nous
		{
			XTarget=X;
			YTarget=Y_CONTENEUR;
			Flag_Inter=0;				
		}
		else if (Angle_Adverse<-0.5+PI && Angle_Adverse>0)
		{			
			XTarget=X_INTER_DISTRIBUTEUR;
			YTarget=Y_INTER_DISTRIBUTEUR;	
			Flag_Inter=1;
			Angle_Propulsion (0,50);										// Se roriente vers le conteneur (au cas ou l'adversaire nous aurait touch)
			while (	Etat_Propulsion ()!='a' &&
					Etat_Propulsion ()!='g');
		}	
		else
		{
			XTarget=X_INTER_CONTENEUR;
			YTarget=Y_INTER_CONTENEUR;				
			Flag_Inter=1;
			Angle_Propulsion (-PI/2.0,50);										// Se roriente vers le conteneur (au cas ou l'adversaire nous aurait touch)
			while (	Etat_Propulsion ()!='a' &&
					Etat_Propulsion ()!='g');
		}
	}
	
	
	
	
	
	// ------------------------------------------------------------------
	// Phase 1 : Dplacement
	//
	
	GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);							// Se dplace jusqu'au point demand en marche arrire
	while (Etat_Propulsion ()!='a')											// Tant qu'on est pas arriv
	{
	
	
	
		if (Flag_Inter)														// Si on traque un point intermdiaire
		{
			if (CONDITION_CHANGE_DIR)										// Si on pass la moiti du terrain
			{		
				XTarget=X;													// On va directement vers la cible
				YTarget=Y_CONTENEUR;										
				Flag_Inter=0;												// On baisse le flag 
				GotoXY_Propulsion(	XTarget, YTarget,-VIT_LENTE);			// Se dplace jusqu'au point demand en marche arrire
			}
		}
		
		
		
		
		if (Etat_Propulsion()=='g')											// Si le robot est bloqu
		{
			Stop_Propulsion();												// On stoppe les moteurs
			print_str("Evitement blocage\n");											
			ToutDroit_Propulsion(150,40);									// On avance
			while ( Etat_Propulsion()!='a' &&							
					Etat_Propulsion()!='g');
			Evite_Robot_Adverse();											// Routine d'vitement du robot adverse
			NbEvitements++;	
			if (NbEvitements<=3)
			{
				XTarget=X;													// On a rencontr l'adversaire, on va directement  la cible
				YTarget=1700;
			}
			else
			{
				XTarget=500;												// On a rencontr l'adversaire plus de 3 fois, on va directement  la cible
				YTarget=1700;
			}
			if (NbEvitements>=4)											// Aprs 3 vitements et un forage, on est pas pass : tant pis :
			{
				Stop_Propulsion();
				while (Etat_Propulsion()!='a');
			}
			else
				GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);				// Se dplace jusqu'au point demand en marche avant
			Flag_Inter=0;													// On ne passe plus par un point intermdiaire
			
		}
		
		
		
		if 	(Angle_Robot_Adverse()<32  || 									// Si le robot est potentiellement sur la trajectoire
			Angle_Robot_Adverse()>223 ||
			Distance_Robot_Adverse()==0)									// Ou si on ne le voit pas !
										
		{	
				
			if 	((Telemetre_Arriere_Droit()>DISTANCE_OBSTACLE ||			// On teste les capteurs  droite ...
				Telemetre_Arriere_Gauche()>DISTANCE_OBSTACLE)	&&			// ... et  gauche
				(NbEvitements<3))											// On ne l'a pas vit 3 fois
			{
				Stop_Propulsion();											// On arrte le robot
				
				Xrobot=X_Propulsion();										// On lit la position du robot
				Yrobot=Y_Propulsion();
				
				Distance_Cible=(X-Xrobot)*(X-Xrobot)+(Y_CONTENEUR-Yrobot)*(Y_CONTENEUR-Yrobot);	// Calcule la distance entre le robot et la cible
				
				
				if (Distance_Cible<250000)									// On fait un vitement trop proche de la cible, on switch de cible
				{
					print_str("Switch target\n");
					Delay10KTCYx(200);										// On attends pour ne pas faire du wheeling
					GotoXY_Propulsion(2400,Y_CONTENEUR,100);				// On change de position: on va chez lui
					Nb_Depose_Adverse++;									// On incrmente le nombre de dposes chez l'adversaire	
					while (Etat_Propulsion()!='a' &&						// On attends la fin de la manoeuvre
							Etat_Propulsion()!='g');
					Stop_Propulsion();										// On arrte les moteurs
					while (Etat_Propulsion()!='a');							// Du coup, on doit aussi quitter la boucle principale
				}
				else
				{
					print_str("Evitement capteurs\n");
					
					while (	Etat_Propulsion ()!='a');							// On attends d'tre compltement stopp
				
					Evite_Robot_Adverse();										// Routine d'vitement du robot adverse
					NbEvitements++;
					XTarget=X;													// On a rencontr l'adversaire, on va directement  la cible
					YTarget=Y_CONTENEUR;
					Flag_Inter=0;									
					GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);					// Se dplace jusqu'au point demand en marche arrire
				}
			}
		}
		else
		{
			GotoXY_Propulsion(XTarget,YTarget,-VIT_RAPIDE);					// Se dplace jusqu'au point demand en marche arrire  fond
			while ( Angle_Robot_Adverse()>=32  &&							// Jusqu' ce que le robot revienne sur la trajectoire ...
					Angle_Robot_Adverse()<=223 &&		
					Distance_Robot_Adverse()!=0 &&							// ... ou si on ne le voit plus ... 
					Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g')									// ... ou qu'on est arriv ...
					
			{
				if (Flag_Inter)												// Si traque le robot adverse
				{
					if (CONDITION_CHANGE_DIR)								// Si on pass la moiti du terrain
					{		
						XTarget=X;											// On va directement vers la cible
						YTarget=Y_CONTENEUR;										
						Flag_Inter=0;										// On baisse le flag 
						GotoXY_Propulsion(	XTarget,YTarget,-VIT_RAPIDE);	// On envoie l'ordre d'aller au point final
					}
				}
			}
			if (Etat_Propulsion()!='a')										// Si on est pas arriv ...
				GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);					// ... on ralentit !
		}		
	}
	Stop_Propulsion();														// Coupe les moteurs
	while (Etat_Propulsion ()!='a');										// Laisse le temps  la carte de s'arrter
	
	
	// ------------------------------------------------------------------
	// Phase 2 : Orientation et attends que le chemin soit libre
	//
	
	Angle_Propulsion (-PI/2.0,40);											// S'oriente vers le conteneur
	while (Etat_Propulsion ()!='a');

	NbEvitements=0;
	while ((Telemetre_Arriere_Droit()>DISTANCE_OBSTACLE ||					// On regarde s'il y a un robot derrire nous
			Telemetre_Arriere_Gauche()>DISTANCE_OBSTACLE) && 
			NbEvitements<50)
	{
		NbEvitements++;														// On incrmente le nombre d'vitements
		Delay10KTCYx(20);													// On attends un peu
		Angle_Propulsion (-PI/2.0,20);										// Se roriente vers le conteneur (au cas ou l'adversaire nous aurait touch)
		while (Etat_Propulsion ()!='a');
	}		
	


	// ------------------------------------------------------------------
	// Phase 3 : Callage
	//
	
	ToutDroit_Propulsion (700, -50);										// On recule rapidement
	while (	Y_Propulsion ()<1900 &&											// Soit on est tout pret de la bordure				
			Etat_Propulsion ()!='a' &&										// Soit on est arriv ???
			Etat_Propulsion ()!='g');										// Soit on est bloqu
						
	NbEvitements=0;
	
	
	ToutDroit_Propulsion (1500, -20);										// On recule gentiment pour se caller
	while (! (IO_Sw_Gauche () && IO_Sw_Droit ()) && NbEvitements<4)							// Jusqu' ce qu'on est les deux switchs
	{
		if (Etat_Propulsion ()=='g')										// Si le robot est bloqu (on a coinc l'adversaire ?)
		{
			ToutDroit_Propulsion (350, 50);									// On avance de 35 cm
			while (	Etat_Propulsion ()!='g' &&								// Jusqu' ce que l'on soit de nouveau bloqu ...
					Etat_Propulsion ()!='a');								// ... ou arriv
			Delay10KTCYx(255);												// On attends pour que le robot adverse puisse se faire la malle
			NbEvitements++;
			if (NbEvitements==2)
			{
				if (Distance_Robot_Adverse()==0 || 
					(Angle_Absolu_Robot_Adverse ()<PI/2.0 && 
					Angle_Absolu_Robot_Adverse ()>-PI/2.0) )
					GotoXY_Propulsion(X_CONTENEUR_SECOURS,Y_CONTENEUR,50);						// On change de position 
				else
					GotoXY_Propulsion(2400,Y_CONTENEUR,80);						// On change de position 
					
				while (	Etat_Propulsion ()!='g' &&							// Jusqu' ce que l'on soit de nouveau bloqu ...
				Etat_Propulsion ()!='a');									// ... ou arriv
				
				Angle_Propulsion (-PI/2.0,30);								// Se roriente vers le conteneur (au cas ou l'adversaire nous aurait touch)
				while (	Etat_Propulsion ()!='g' &&							// Jusqu' ce que l'on soit de nouveau bloqu ...
				Etat_Propulsion ()!='a');									// ... ou arriv			
				ToutDroit_Propulsion (1500, -50);							// On recule  nouveau	
				
				while (	Y_Propulsion ()<1900 &&											// Soit on est tout pret de la bordure				
					Etat_Propulsion ()!='a' &&										// Soit on est arriv ???
					Etat_Propulsion ()!='g');										// Soit on est bloqu			
			}
			ToutDroit_Propulsion (1500, -20);								// On recule gentiment pour se caller
		}
	}
	Delay10KTCYx(1);

																			// On attends un poil pour que le robot soit bien coll sur le bord
	if (IO_Sw_Gauche () && IO_Sw_Droit ())									// Si on a les deuxc switchs ...
		Force_Propulsion(X_Propulsion(),2049,-1571);						// ... recallage le robot sur le bord	
	else																	// Sinon
	{													
			ToutDroit_Propulsion (1500, -20);								// Tant pis, on recule ...
			while (	Etat_Propulsion ()!='g' &&								// Jusqu' ce que l'on soit de nouveau bloqu ...
					Etat_Propulsion ()!='a');								// ... ou arriv
	}
		
	Stop_Propulsion();														// On arrte les moteurs, car on est call !
	return NbEvitements;													// On retourne le nombre d'vitements
}





// --------------------------------------------------------------------------
/* Avance et oriente lgrement le robot dans le sens de la pente
 * puis depose les balles
 * Arguments : 
 * 	- la couleur que l'on va jouer durant ce match
 * 
 * Paramtre retourn : 
 *   0 : tout s'est bien pass,
 * 	-1 : Une collision s'est produite sur le BUS IC ou l'esclave n'a pas renvoy d'acknoledgment aprs l'adresse
*/
void Depose_Balles (char Couleur)
{	
	static char DerniereCouleur=NONE;						// Couleur de la dernire balle dpose
	char NbBlanche,NbCouleur;								// Variables contenant le nombre de balles blanches et de couleur

	ToutDroit_Propulsion (20,20);							// Avance le robot de 2 cm
	while (Etat_Propulsion ()!='a');

	if (X_Propulsion()>650)									// Si on est pas tout au bout du conteneur standard
	{
		if (X_Propulsion()<1500)
			Angle_Propulsion (-PI/2.0-0.3,20);					// Tourne lgrement le robot pour viter que les balle ne passe par dessus le bord	
		else 
			Angle_Propulsion (-PI/2.0+0.15,20);
	}
	
	NbBlanche=NbBalles_Barillet(BLANCHE);					// Compte le nombre de balles blanches
	NbCouleur=NbBalles_Barillet(Couleur);					// Compte le nombre de balles de notre couleur
	
	while (NbBlanche || NbCouleur)							// Tant qu'il reste des balles dans le barillet		
	{		
		switch (DerniereCouleur)							// Selon la dernire couleur dpose
		{

			case NONE : 									// C'est la premire fois qu'on dpose des balles (c'ets pareil que si c'tait une couleur)
			case ROUGE :									// La dernire balle dpose tait rouge ...
			case BLEUE :									// ... ou bleue
				if (NbBlanche) 								// Si on peut dposer une blanche
				{
					DeposeBalle_Barillet(BLANCHE);			// On dpose la blanche												
					DerniereCouleur=BLANCHE;				// On mmorise la couleur	
					NbBlanche--;
				}
				else										// Sinon, on commence par une couleur
				{
					DeposeBalle_Barillet(Couleur);			// On dpose la bleue
					DerniereCouleur=Couleur;				// On mmorise la couleur	
					NbCouleur--;							// On enlve une balle
				}
				break;	

			case BLANCHE : 									// La dernire balle dpose tait blanche
				if (NbCouleur) 								// Si on peut dposer une couleur
				{
					DeposeBalle_Barillet(Couleur);			// On dpose la couleur
					DerniereCouleur=Couleur;				// On mmorise la couleur	
					NbCouleur--;							// On enlve une balle
				}
				else										// Sinon, on commence par une bleue
				{
					DeposeBalle_Barillet(BLANCHE);			// On dpose la blanche												
					DerniereCouleur=BLANCHE;				// On mmorise la couleur	
					NbBlanche--;	
				}
				break;
			Delay10KTCYx(10);								// Tempo pour ne pas saturer l'IC						
		}
	}				
	
	Delay10KTCYx(250);		
	while (Barillet_Busy());
}	









// --------------------------------------------------------------------------
/* Routine d'vitement du robot adverse :
 * On tourne le robot pour avoir l'adversaire soit sur un ct gauche ou droit  90
 * Puis on regarde s'il est devant ou derrire et on avance ou recule en consquence 
 * La distance parcouru est dpendante de la nouvelle position du robot
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *  aucun
*/
void Evite_Robot_Adverse(void)
{
	float 			Angle_Adverse;											// Angle form avec le robot adverse
	float 			Angle_Robot;											// Orientation courante du robot
	
	//----------- Phase 0, on fait l'acquisition de toutes les donnes (capteur, position de l'adversaire ...)
	
	if (Distance_Robot_Adverse()==0)										// Si on ne sait pas ou se trouve le robot adverse
		Angle_Adverse=0;													// On suppose qu'il est pile en face
	else
	{
		Angle_Adverse=Angle_Robot_Adverse();								// Mesure de l'angle du robot adverse
		Angle_Adverse=Angle_Adverse*2.0*PI/255.0;							// Conversion l'angle de l'adversaire en radians		
	}
	Angle_Robot=A_Propulsion()/1000.0;										// Mesure et convertit l'angle du robot en radian
		
	
	
	//----------- Phase 1, on tourne de faon  avoir l'adversaire sur le ct
	
	if (Angle_Adverse>=0 && Angle_Adverse<=PI)								// Si le robot adverse est sur le ct droit
	{
		Angle_Propulsion (Angle_Robot-PI/2+Angle_Adverse,VIT_EVIT);			// On tourne pour se positionner  90
		while (	Etat_Propulsion ()!='a');									// On attends la fin du mouvement						
	}
	else																	// Si le robot adverse est  gauche
	{
		Angle_Propulsion (Angle_Robot-1.5*PI+Angle_Adverse,VIT_EVIT);		// On tourne pour se positionner  90
		while (	Etat_Propulsion ()!='a');									// On attends la fin du mouvement						
	}
	
	
	
	//----------- Phase 2, on avance ou on recule
	
	Delay10KTCYx(150);														// Attends avant de faire une nouvelle mesure sur la tourelle

	if (Distance_Robot_Adverse()==0)										// Si on ne sait pas ou se trouve le robot adverse
		Angle_Adverse=63;													// On prends le cas le plus dfavorable
	else
		Angle_Adverse=Angle_Robot_Adverse();								// On mesure la nouvelle position de l'adversaire

	


	if (Angle_Adverse<64.0)													// On regarde dans quel cadran se trouve le robot adverse
		ToutDroit_Propulsion ((int)(Angle_Adverse*8.0),VIT_EVIT);			// On avance d'une distance relative  l'angle du robot
	else if (Angle_Adverse<128.0)											// On est dans le 2me cadran
		ToutDroit_Propulsion ((int)((128.0-Angle_Adverse)*8.0),-VIT_EVIT);	// On recule d'une distance relative  l'angle du robot
	else if (Angle_Adverse<192.0)											// On est dans le 3me cadran
		ToutDroit_Propulsion ((int)((Angle_Adverse-128)*8.0),-VIT_EVIT);	// On recule d'une distance relative  l'angle du robot
	else 																	// On est dans le 4me cadran
		ToutDroit_Propulsion ((int)((255-Angle_Adverse)*8.0),VIT_EVIT);		// On avance d'une distance relative  l'angle du robot
	while (	Etat_Propulsion ()!='a'	&&										// Jusqu' ce la fin du mouvement ...	
			Etat_Propulsion ()!='g' &&										// ... ou que le robot est bloqu ...
			X_Propulsion()>400 &&											// ... ou il trop proche des bords
			X_Propulsion()<2600 &&
			Y_Propulsion()>400 &&
			Y_Propulsion()<1700);
			
	Stop_Propulsion();
	
	
	//----------- Phase 3, On revient sur l'orientation initiale	
	
	Angle_Propulsion (Angle_Robot,VIT_EVIT);								// On tourne pour revenir dans la position initiale
	while (	Etat_Propulsion ()!='a');										// Jusqu' la fin du mouvement

}






//-----------------------------------------------------------------------
/* Le robot se place en dfense de notre ct en protgeant les balles
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *	 aucun
 */
void Defense_Bleue(void)
{
	if (Y_Propulsion()>1700)									// Si on est dj du ct du conteneur standard 
	{
		if (A_Propulsion()>0)									// On regarde comment on est orient
			ToutDroit_Propulsion(400,-30);						// On recule ...
		else
			ToutDroit_Propulsion(400,30);						// Ou on avance
		while ( Etat_Propulsion()!='a' &&						// Jusqu' la fin du mouvement
				Etat_Propulsion()!='g');
	}
	
	Goto_Conteneur (1100);										// On se place en position de dfense
	while (1)
	{
		LCD_GotoXY(1,3);										// On affiche le temps qui reste
		print_int (90-Sec_depuis_debut ());						// On affiche le dcompte du temps
		print_str(" ");
		Delay10KTCYx(30);
	}	
} 